import Vue from 'vue'
import Vuex from 'vuex'

import state from '@/store/state'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import actions from '@/store/actions'

import cart from '@/store/modules/cart'
import currency from '@/store/modules/currency'
import customer from '@/store/modules/customer'
import date from '@/store/modules/date'
import journal from '@/store/modules/journal'
import payment from '@/store/modules/payment'
import product from '@/store/modules/product'
import user from '@/store/modules/user'

Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        cart,
        currency,
        customer,
        date,
        journal,
        payment,
        product,
        user
    },
    strict: true
})

export default store