import { 
    SET_DATE, 
    SET_LOADING_DATE 
} from '@/constants/mutationTypes'

import { 
    INIT_DATE, 
    RESET_DATE 
} from '@/constants/actionTypes'

const initialState = {
    date: null,
    loadingDate: false
}

const state = {
    date: initialState.date,
    loadingDate: !initialState.loadingDate
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    date(state) {
        return state.date
    },
    /**
     * 
     * @param {*} state 
     */
    loadingDate(state) {
        return state.loadingDate
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_DATE] (state, payload) {
        state.date = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_DATE] (state, payload) {
        state.loadingDate = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_DATE] ({ commit }, payload) {
        commit(SET_DATE, payload)
        commit(SET_LOADING_DATE)
    },
    /**
     * 
     * @param {*} param0 
     */
    [RESET_DATE] ({ commit }) {
        commit(SET_LOADING_DATE, true)
        commit(SET_DATE, null)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}