import { 
    SET_USER, 
    SET_LOADING_USER 
} from '@/constants/mutationTypes'

import { 
    INIT_USER,
    RESET_USER
} from '@/constants/actionTypes'

const initialState = {
    user: null,
    loadingUser: false
}

const state = {
    user: initialState.user,
    loadingUser: !initialState.loadingUser
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    user(state) {
        return state.user
    },
    /**
     * 
     * @param {*} state 
     */
    loadingUser(state) {
        return state.loadingUser
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_USER] (state, payload) {
        state.user = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_LOADING_USER] (state, payload) {
        state.loadingUser = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_USER] ({ commit }, payload) {
        commit(SET_USER, payload)
        commit(SET_LOADING_USER)
    },
    /**
     * 
     * @param {*} param0 
     */
    [RESET_USER] ({ commit }) {
        commit(SET_LOADING_USER, true)
        commit(SET_USER, null)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}